//#########################################################################
// 
// Project  :  StopWatch   V  1.00
//   
// Program  :  Main Program
//   
// Author   :  David Coz  
//
// Mail     :  Coz.hubert@infonie.fr
//
//  A quite precise StopWatch (hundredths display) 
//
// Created 12/07/2002; 14:47:25
//
//##########################################################################




#define USE_TI92PLUS
#define USE_V200
              // Produce .89z File

#define OPTIMIZE_ROM_CALLS // Use ROM Call Optimization

#define SAVE_SCREEN           // Save/Restore LCD Contents

#include <tigcclib.h>         // Include All Header Files


// Some variable for the Digits Display
int y_digit=38+14;//38
int x_start=24+20;//24


/*Small Digits Sprites*/
char small_digit[10][7]={
{0x60,0x90,0x90,0x00,0x90,0x90,0x60},
{0x00,0x10,0x10,0x00,0x10,0x10,0x00},	
{0x60,0x10,0x10,0x60,0x80,0x80,0x60},
{0x60,0x10,0x10,0x60,0x10,0x10,0x60},
{0x00,0x90,0x90,0x60,0x10,0x10,0x00},
{0x60,0x80,0x80,0x60,0x10,0x10,0x60},
{0x60,0x80,0x80,0x60,0x90,0x90,0x60},
{0x60,0x10,0x10,0x00,0x10,0x10,0x00},
{0x60,0x90,0x90,0x60,0x90,0x90,0x60},
{0x60,0x90,0x90,0x60,0x10,0x10,0x60}};

/*Big Digits Sprites*/
char big_digit[10][14]={
{0x3C,0x3C,0xC3,0xC3,0xC3,0xC3,0x00,0x00,0xC3,0xC3,0xC3,0xC3,0x3C,0x3C},
{0x00,0x00,0x03,0x03,0x03,0x03,0x00,0x00,0x03,0x03,0x03,0x03,0x00,0x00},	
{0x3C,0x3C,0x03,0x03,0x03,0x03,0x3C,0x3C,0xC0,0xC0,0xC0,0xC0,0x3C,0x3C},
{0x3C,0x3C,0x03,0x03,0x03,0x03,0x3C,0x3C,0x03,0x03,0x03,0x03,0x3C,0x3C},
{0x00,0x00,0xC3,0xC3,0xC3,0xC3,0x3C,0x3C,0x03,0x03,0x03,0x03,0x00,0x00},
{0x3C,0x3C,0xC0,0xC0,0xC0,0xC0,0x3C,0x3C,0x03,0x03,0x03,0x03,0x3C,0x3C},
{0x3C,0x3C,0xC0,0xC0,0xC0,0xC0,0x3C,0x3C,0xC3,0xC3,0xC3,0xC3,0x3C,0x3C},
{0x3C,0x3C,0x03,0x03,0x03,0x03,0x00,0x00,0x03,0x03,0x03,0x03,0x00,0x00},
{0x3C,0x3C,0xC3,0xC3,0xC3,0xC3,0x3C,0x3C,0xC3,0xC3,0xC3,0xC3,0x3C,0x3C},
{0x3C,0x3C,0xC3,0xC3,0xC3,0xC3,0x3C,0x3C,0x03,0x03,0x03,0x03,0x3C,0x3C}};


char big_digit_mask[14]=
{	0x00,0x00,0x00,0x00,0x00,0x00,0x00,	0x00,0x00,0x00,0x00,0x00,0x00,0x00};

char small_digit_mask[7]=
{0x0F,0x0F,0x0F,0x0F,0x0F,0x0F,0x0F};

char separator[6]=
{0xC0,0xC0,0x00,0x00,0xC0,0xC0};



/*Function that returns the Hardware Version*/
/*Found in the Tigcc Help.Thanx to Zeljko Juric*/
unsigned long GetHardwareVersion ()
{
  unsigned long hwpb, *rombase;
  rombase = (unsigned long *)((*(unsigned long *)0xC8) & 0x600000);
  hwpb = rombase[65];
  return (hwpb - (unsigned long)rombase  < 0x10000 &&
    *(unsigned short *)hwpb > 22 ? *(unsigned long *)(hwpb + 22) : 1);
}


//Clock variables...

INT_HANDLER oldint5 = NULL;

volatile long int ms  = 0; // 1/146 seconds,used for the key delay
volatile int mseconds = 0; // 1/146 seconds
volatile int seconds    = 0; // one second
volatile int minutes    = 0;  // one minute
volatile int reset  = 1;  // reset the clock
volatile int run  = 0;     // if 1,the clock is running...


// Clock Definition
// Thanx to Thomas Nussbaumer for his tutorial on Clocks...

DEFINE_INT_HANDLER (myint5handler) {
    //----------------------------------------------
    // if resettime is not 0 all clock variables are
    // reset to 0
    //----------------------------------------------
    ms++;
    
    // Reset Values
    if (reset) {
       ms=mseconds=seconds=minutes=reset=0;}
    
    // if the Clock is running
    else if (run){
    
        mseconds++;
      
        if (mseconds == 146) {   // 146 * mseconds = one second
            mseconds = 0;
            seconds++;
            if (seconds == 60) {
                seconds = 0;
                minutes++;
              }
        }
    }
    ExecuteHandler(oldint5);
}






/*Display the Digits*/

void display_digit()
{
/*Minutes Display*/
	Sprite8(x_start,y_digit,14,big_digit[8],GetPlane(0),SPRT_OR);
	Sprite8(x_start,y_digit,14,big_digit_mask,GetPlane(1),SPRT_AND);
	Sprite8(x_start,y_digit,14,big_digit[minutes/10],GetPlane(1),SPRT_OR);

	Sprite8(x_start+10,y_digit,14,big_digit[8],GetPlane(0),SPRT_OR);
	Sprite8(x_start+10,y_digit,14,big_digit_mask,GetPlane(1),SPRT_AND);
	Sprite8(x_start+10,y_digit,14,big_digit[minutes%10],GetPlane(1),SPRT_OR);
	
/*Seconds Display*/

	Sprite8(x_start+24,y_digit,14,big_digit[8],GetPlane(0),SPRT_OR);
	Sprite8(x_start+24,y_digit,14,big_digit_mask,GetPlane(1),SPRT_AND);
	Sprite8(x_start+24,y_digit,14,big_digit[seconds/10],GetPlane(1),SPRT_OR);
	
	Sprite8(x_start+34,y_digit,14,big_digit[8],GetPlane(0),SPRT_OR);
	Sprite8(x_start+34,y_digit,14,big_digit_mask,GetPlane(1),SPRT_AND);
	Sprite8(x_start+34,y_digit,14,big_digit[seconds%10],GetPlane(1),SPRT_OR);
	

/*Hundredths Display*/
int hundredth = (mseconds*100)/(146);

	Sprite8(x_start+44,y_digit+7,7,small_digit[8],GetPlane(0),SPRT_OR);
	Sprite8(x_start+44,y_digit+7,7,small_digit_mask,GetPlane(1),SPRT_AND);
	Sprite8(x_start+44,y_digit+7,7,small_digit[hundredth/10],GetPlane(1),SPRT_OR);
	
	Sprite8(x_start+49,y_digit+7,7,small_digit[8],GetPlane(0),SPRT_OR);
	Sprite8(x_start+49,y_digit+7,7,small_digit_mask,GetPlane(1),SPRT_AND);
	Sprite8(x_start+49,y_digit+7,7,small_digit[hundredth%10],GetPlane(1),SPRT_OR);

/*Separator Display*/
   
	Sprite8(x_start+20,y_digit+4,6,small_digit_mask,GetPlane(0),SPRT_AND);
	Sprite8(x_start+20,y_digit+4,6,small_digit_mask,GetPlane(1),SPRT_AND);

/*Display the Separator during  50 hundredths*/
	if (hundredth>50)
	return;
		
	Sprite8(x_start+20,y_digit+4,6,separator,GetPlane(0),SPRT_OR);
	Sprite8(x_start+20,y_digit+4,6,separator,GetPlane(1),SPRT_OR);
	
}



/*Draw the Stop Watch Bitmap*/
void draw_stop_watch()
{
SetPlane(0);
ClrScr();
DrawStr(100+40,10+10,"StopWatch",A_NORMAL);
DrawStr(101+40,11+10,"StopWatch",A_NORMAL);
BitmapPut(2+20,0+14,(BITMAP *)&(unsigned char[]){0,100,0,96,
0x00,0x00,0x00,0x00,0x0E,0x00,0x00,0x58,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x60,0x04,0x20,0x01,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x03,0x01,0xFF,0xF0,0x00,0x60,0x00,0x00,0x00,0x00,0x00,0x00,0x08,0x1F,0xFF,0xF8,0x00,0x08,0x00,0x00,0x00,0x00,0x00,0x74,0x40,0xFF,0xFF,0xFF,0xC2,0x01,0x02,0x80,0x00,0x00,0x07,0xF9,0x03,0xFF,0xFF,0x3F,0xF0,0x00,0x1F,0xC0,0x00,0x00,0x03,0xF8,0x07,0xFF,0xFF,0xFF,0xF8,0x00,0x1F,0xE8,0x00,0x00,0x1F,0xFC,0x3F,0xFC,0x7F,0xFF,0xFD,0xA0,0x1F,0xFA,0x00,0x00,0x39,0xFE,0xFF,0xF0,0x00,0x3F,0xFB,0xC0,0x0F,0xFE,0x00,0x00,0x63,0xFF,0xFE,0x00,0x00,0x07,0xFF,0xC1,0x87,0xFF,0x00,0x00,0xC0,0xFF,0xF8,0x00,0x00,0x00,0xFF,0xF2,0x41,0xF8,0x00,0x00,0x83,0xFF,0x80,0x38,0x00,0x00,0xFF,0xFA,0x42,0x51,0x40,0x01,0x03,0xFF,0x00,0x18,0x00,0x0C,0x0F,0xFC,0x23,0x30,0x80,0x02,0x07,0xF8,0x00,0x58,0x3F,0xFC,0x0F,0xFF,0x00,0x00,0x00,0x00,0x1F,0xF0,0x00,0x07,0xFF,0xFF,0xF3,0xCF,0x80,0x00,0x00,0x02,0x0F,0xE0,0x00,0x3F,0xFF,0xFF,0xFC,0x77,0xE0,0x00,0x00,0x00,0x1F,0xC0,0x00,0xFF,0xFB,0x4F,0xFF,0x8F,0xE0,0x00,0x00,0x01,0x7F,0x80,0x03,0xFF,0xFB,0x9F,0xFF,0xE3,0xF0,0x00,0x40,0x01,0x7F,0x00,0x0F,0xFF,0xFF,0xBF,0xFF,0xF8,0x30,0x00,0x40,0x00,0x7E,0x02,0x1F,0xFF,0xFD,0x4F,0xFF,0xFC,0x00,0x00,0x40,0x00,0x7C,0x00,0x7F,0xFF,0xFF,0xFF,0xFF,0xFF,0x00,0x00,0x20,0x00,0xF8,0x00,0xFF,0xFC,0x4A,0x10,0xFF,0xFF,0xC0,0x00,0x00,0x01,0xF0,0x03,0xCF,0xFF,0xCE,0x30,0x5F,0xEF,0xE0,0x00,0x10,0x09,0xE0,0x07,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xF0,0x00,0x10,0x09,0xE0,0x07,0xE2,0x7F,0xFF,0xFF,0xFF,0x43,0xF8,0x00,0x18,0x03,0xC0,0x1F,0xCD,0x7F,0xFF,0xFF,0xFF,0xB7,0xFC,0x00,0x08,0x13,0xC0,0x1F,0xFF,0xFF,0xEF,0xEF,0xFF,0xAF,0xFE,0x00,0x0C,0x0F,0x80,0x7F,0xF9,0x7E,0x6A,0x8F,0x3F,0x37,0xFF,0x00,0x0C,0x0F,0x80,0x7F,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0x00,0x04,0x2F,0x00,0x7F,0xFF,0x7F,0xFF,0xF0,0x02,0x00,0x1F,0x80,0x86,0x1E,0x01,0xE4,0x00,0x00,0x00,0x00,0x00,0x00,0x3B,0xC0,0x02,0x5E,0x03,0xE8,0x00,0x00,0x00,0x00,0x00,0x00,0x0F,0xE0,0x43,0x1E,0x03,0xE8,0x00,0x00,0x00,0x00,0x00,0x00,0x0F,0xE0,0x43,0x1C,0x0F,0xE8,0x00,0x00,0x00,0x00,0x00,0x00,0x0F,0xF0,0x41,0x3C,0x07,0xE8,0x00,0x00,0x00,0x00,0x00,0x00,0x0F,0xF0,0x21,0x3C,0x17,0xE8,0x00,0x00,0x00,0x00,0x00,0x00,0x0F,0xF8,0x01,0xBC,0x1F,0xE8,0x00,0x00,0x00,0x00,0x00,0x00,0x0F,0xF8,0x31,0xB8,0x0F,0xE8,0x00,0x00,0x00,0x00,0x00,0x00,0x0F,0xF8,0x31,0xB8,0x0F,0xE8,0x00,0x00,0x00,0x00,0x00,0x00,0x0F,0xF8,0x31,0x18,0x0F,0xE8,0x00,0x00,0x00,0x00,0x00,0x00,0x0F,0xF8,0x31,0x30,0x1F,0xE8,0x00,0x00,0x00,0x00,0x00,0x00,0x0F,0xFC,0x31,0x10,0x1F,0xE8,0x00,0x00,0x00,0x00,0x00,0x00,0x0F,0xFC,0x31,0x38,0x1F,0xE8,0x00,0x00,0x00,0x00,0x00,0x00,0x0F,0xFC,0x11,0x30,0x1F,0xE8,0x00,0x00,0x00,0x00,0x00,0x00,0x0F,0xFC,0x31,0x30,0x1F,0xE8,0x00,0x00,0x00,0x00,0x00,0x00,0x0F,0xFC,0x31,0x30,0x1F,0xE8,0x00,0x00,0x00,0x00,0x00,0x00,0x0F,0xFC,0x19,0x30,0x1F,0xE8,0x00,0x00,0x00,0x00,0x00,0x00,0x0F,0xFC,0x01,0x38,0x1F,0xE8,0x00,0x00,0x00,0x00,0x00,0x00,0x0F,0xFC,0x01,0x30,0x1F,0xE8,0x00,0x00,0x00,0x00,0x00,0x00,0x0F,0xFC,0x19,0x30,0x1F,0xE8,0x00,0x00,0x00,0x00,0x00,0x00,0x0F,0xFC,0x39,0x30,0x1F,0xE0,0x00,0x00,0x00,0x00,0x00,0x00,0x0F,0xFC,0x39,0x30,0x5F,0xE0,0x00,0x00,0x00,0x00,0x00,0x00,0x0F,0xFC,0x39,0x30,0x5F,0xE0,0x00,0x00,0x00,0x00,0x00,0x00,0x0F,0xFC,0x39,0x30,0x5F,0xE0,0x00,0x00,0x00,0x00,0x00,0x00,0x0F,0xFC,0x39,0x20,0x5F,0xE0,0x00,0x00,0x00,0x00,0x00,0x00,0x0F,0xFC,0x39,0x30,0x5F,0xE0,0x00,0x00,0x00,0x00,0x00,0x00,0x0F,0xFC,0x39,0x20,0x5F,0xE0,0x00,0x00,0x00,0x00,0x00,0x00,0x0F,0xF8,0x39,0x00,0x1F,0xE8,0x00,0x00,0x00,0x00,0x00,0x00,0x0F,0xFC,0x38,0x30,0x1F,0xE0,0x00,0x00,0x00,0x00,0x00,0x00,0x27,0xFE,0x18,0x20,0x0F,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xC0,0x1F,0xF8,0x19,0x80,0x6F,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xF8,0x39,0x7F,0xF7,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xE0,0x72,0x00,0x7C,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xC2,0xFC,0x00,0x2A,0x7F,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0x00,0x3D,0x00,0x07,0xA7,0xFD,0xFF,0xF6,0x60,0xFF,0x5F,0xF0,0x18,0x08,0x40,0xC3,0x04,0xFF,0x1F,0xC6,0xEA,0xFE,0x1F,0x90,0x13,0xFD,0xB8,0x24,0x78,0xA7,0xF6,0xFF,0xFF,0xFF,0xF8,0x22,0xC3,0xCF,0x00,0x0C,0x0E,0xD4,0xF9,0xFF,0xFF,0xFF,0xC0,0x17,0xE8,0x38,0x00,0x00,0x01,0xCD,0xBF,0xFF,0xFF,0xFF,0x02,0xBF,0xE0,0x01,0x03,0xFC,0x00,0x7A,0x4F,0xFF,0xFF,0xF9,0x87,0xFF,0xA0,0x02,0x00,0x39,0x00,0x00,0x63,0x2F,0xFA,0x42,0xFF,0xFF,0xC0,0x79,0x00,0x0D,0x00,0x00,0x38,0xA3,0xC1,0x21,0xFF,0xFF,0x80,0x39,0x80,0x3E,0x80,0x00,0x03,0x77,0xF6,0xBF,0xFF,0xFF,0x80,0x31,0x00,0x3F,0x40,0x00,0x00,0x9F,0xF8,0x7F,0xFF,0xFF,0x40,0x71,0x40,0x7F,0xE0,0x00,0x00,0xFF,0xC8,0xFF,0xFF,0xFE,0x00,0x63,0x40,0x3F,0xD0,0x00,0x00,0x9F,0xC6,0x7F,0xFF,0xFC,0x00,0x02,0x20,0x3F,0xD0,0x00,0x00,0x3F,0x87,0xFF,0xFF,0xF0,0x00,0x02,0x20,0x3F,0xC4,0x00,0x01,0x7C,0x80,0xFF,0xFF,0xF1,0x20,0x04,0x00,0x0F,0xD2,0x00,0x01,0x79,0x92,0x7F,0xFF,0xA0,0x00,0x0C,0x00,0x0F,0xED,0x80,0x00,0xDB,0x97,0x3F,0xFF,0x98,0x00,0x08,0x08,0x07,0xFE,0x80,0x02,0xFF,0xCF,0x7F,0xFE,0x80,0x00,0x18,0x0C,0x07,0xFF,0xC0,0x03,0xF1,0x9B,0x7F,0xFE,0x48,0x00,0x10,0x00,0x03,0xFF,0x98,0x01,0xE3,0x80,0xBF,0xF8,0x00,0x00,0x60,0x02,0x01,0xFF,0xD6,0x05,0xF3,0x9B,0xBF,0xF4,0x80,0x00,0x40,0x00,0x0B,0xFF,0xFE,0xDB,0xE0,0x98,0x65,0x95,0x40,0x00,0x80,0x00,0x8F,0xFF,0xFD,0x37,0xC3,0x80,0xC7,0x38,0x00,0x01,0x80,0x00,0x07,0xFF,0xFF,0xFF,0xE2,0xCB,0xCF,0x20,0x00,0x02,0x00,0x00,0x07,0xFF,0xFF,0xFF,0xFF,0xFC,0x78,0x80,0x00,0x04,0x00,0x00,0x03,0xFF,0xFF,0xFF,0xC3,0x98,0x7F,0xC3,0xFC,0x08,0x00,0x00,0x04,0xFF,0xFF,0xFF,0x83,0x9C,0x7F,0xDF,0xE6,0x10,0x00,0x00,0x00,0x47,0xFF,0xFF,0x03,0x9C,0x7F,0xFF,0xE3,0x00,0x00,0x00,0x00,0x13,0x7F,0xFF,0x03,0x9C,0x7F,0xFB,0x84,0x00,0x00,0x00,0x00,0x02,0x1F,0xFE,0x03,0x9C,0x7F,0xEC,0x20,0x00,0x00,0x00,0x00,0x00,0x87,0xFE,0x03,0x9C,0x7F,0xC0,0x00,0x00,0x00,0x00,0x00,0x00,0x10,0x0E,0x03,0x9C,0x30,0x04,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x08,0xC0,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x08,0x40,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x90,0x40,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x03,0x98,0x40,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x02,0x08,0x40,0x00,0x00,0x00,0x00
},&(SCR_RECT){{0,0,239,127}},A_REPLACE);

SetPlane(1);
ClrScr();
BitmapPut(2+20,0+14,(BITMAP *)&(unsigned char[]){0,100,0,96,
0x00,0x00,0x00,0x00,0x01,0xFF,0xFF,0xA0,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x1F,0xFF,0xFF,0xFE,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xFF,0xFF,0xFF,0xFF,0x80,0x00,0x00,0x00,0x00,0x00,0x00,0x07,0xFF,0xFF,0xFF,0xFF,0xF0,0x00,0x00,0x00,0x00,0x00,0xF8,0x3F,0xFF,0xFF,0xFF,0xFF,0xFE,0x1F,0xC0,0x00,0x00,0x03,0xFE,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xF0,0x00,0x00,0x07,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xF0,0x00,0x00,0x1F,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFC,0x00,0x00,0x3F,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFE,0x00,0x00,0x7F,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0x00,0x00,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0x80,0x01,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFE,0x80,0x01,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0x40,0x01,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xC0,0x03,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xC0,0x01,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xC0,0x01,0xFF,0xFF,0xFF,0xFF,0xFD,0xFF,0xFF,0xFF,0xFF,0xFF,0xC0,0x00,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0x80,0x00,0xFF,0xFF,0xFF,0xFF,0xFF,0xDF,0xFF,0xFF,0xFF,0xFF,0x80,0x01,0xFF,0xFF,0xFF,0xFF,0xFB,0xFF,0xFF,0xFF,0xFF,0xFF,0x80,0x03,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xC0,0x03,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xE0,0x07,0xFF,0xFF,0xF3,0xFF,0xFF,0xFF,0xFF,0x61,0xFF,0xFF,0xE0,0x07,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xE0,0x07,0xFF,0xFF,0xDD,0xFF,0xFF,0xFF,0xFF,0xBF,0xFF,0xFF,0xE0,0x0F,0xFF,0xFF,0xE0,0x7F,0xFF,0xFF,0xFF,0x6F,0xFF,0xFF,0xF0,0x0F,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xF0,0x1F,0xFF,0xFF,0xC4,0xFF,0xFF,0xFF,0xFF,0xCD,0xFF,0xFF,0xF0,0x1F,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xF8,0x1F,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0x78,0x3F,0xFF,0xF8,0x00,0x00,0x00,0x00,0x00,0x00,0x0F,0xFF,0xFC,0x3F,0xFF,0xF0,0x00,0x00,0x00,0x00,0x00,0x00,0x07,0xFF,0xBC,0x7F,0xFF,0xF0,0x00,0x00,0x00,0x00,0x00,0x00,0x07,0xFF,0xBC,0x7F,0xFF,0xF0,0x00,0x00,0x00,0x00,0x00,0x00,0x07,0xFF,0xBE,0x7F,0xFF,0xF0,0x00,0x00,0x00,0x00,0x00,0x00,0x07,0xFF,0xDE,0x7F,0xFF,0xF0,0x00,0x00,0x00,0x00,0x00,0x00,0x07,0xFF,0xFE,0x7F,0xFF,0xF0,0x00,0x00,0x00,0x00,0x00,0x00,0x07,0xFF,0xCE,0x7F,0xFF,0xF0,0x00,0x00,0x00,0x00,0x00,0x00,0x07,0xFF,0xCE,0x7F,0xFF,0xF0,0x00,0x00,0x00,0x00,0x00,0x00,0x07,0xFF,0xCE,0xFF,0xFF,0xF0,0x00,0x00,0x00,0x00,0x00,0x00,0x07,0xFF,0xCE,0xFF,0xFF,0xF0,0x00,0x00,0x00,0x00,0x00,0x00,0x07,0xFF,0xCE,0xFF,0xFF,0xF0,0x00,0x00,0x00,0x00,0x00,0x00,0x07,0xFF,0xCE,0xFF,0xFF,0xF0,0x00,0x00,0x00,0x00,0x00,0x00,0x07,0xFF,0xEE,0xFF,0xFF,0xF0,0x00,0x00,0x00,0x00,0x00,0x00,0x07,0xFF,0xCE,0xFF,0xFF,0xF0,0x00,0x00,0x00,0x00,0x00,0x00,0x07,0xFF,0xCE,0xFF,0xFF,0xF0,0x00,0x00,0x00,0x00,0x00,0x00,0x07,0xFF,0xE6,0xFF,0xFF,0xF0,0x00,0x00,0x00,0x00,0x00,0x00,0x07,0xFF,0xFE,0xFF,0xFF,0xF0,0x00,0x00,0x00,0x00,0x00,0x00,0x07,0xFF,0xFE,0xFF,0xFF,0xF0,0x00,0x00,0x00,0x00,0x00,0x00,0x07,0xFF,0xE6,0xFF,0xFF,0xF0,0x00,0x00,0x00,0x00,0x00,0x00,0x07,0xFF,0xC6,0xFF,0xFF,0xF0,0x00,0x00,0x00,0x00,0x00,0x00,0x07,0xFF,0xC6,0xFF,0xFF,0xF0,0x00,0x00,0x00,0x00,0x00,0x00,0x07,0xFF,0xC6,0xFF,0xFF,0xF0,0x00,0x00,0x00,0x00,0x00,0x00,0x07,0xFF,0xC6,0xFF,0xFF,0xF0,0x00,0x00,0x00,0x00,0x00,0x00,0x07,0xFF,0xC6,0xFF,0xFF,0xF0,0x00,0x00,0x00,0x00,0x00,0x00,0x07,0xFF,0xC6,0xFF,0xFF,0xF0,0x00,0x00,0x00,0x00,0x00,0x00,0x07,0xFF,0xC6,0xFF,0xFF,0xF0,0x00,0x00,0x00,0x00,0x00,0x00,0x07,0xFF,0xC6,0xFF,0xFF,0xF0,0x00,0x00,0x00,0x00,0x00,0x00,0x07,0xFF,0xC7,0xFF,0xFF,0xF8,0x00,0x00,0x00,0x00,0x00,0x00,0x0F,0xFF,0xE7,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xE6,0x7F,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xC6,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0x8C,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xC2,0xFF,0xFF,0xFF,0xFC,0x7F,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xF7,0x3F,0xFF,0xFF,0xFD,0x7F,0xFF,0xFF,0xF8,0x1F,0xFF,0xFF,0xFE,0x7F,0xFF,0xFF,0xFF,0xCB,0xFF,0xFF,0xF3,0xFF,0xFF,0x3F,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xF8,0x1F,0xC7,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xC0,0x1F,0xFE,0x3F,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFE,0x00,0x3F,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0x00,0x00,0x7F,0x86,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFE,0x00,0x00,0x7F,0xC6,0x7F,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xC0,0x00,0x00,0xFF,0xCE,0x7F,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0x80,0x00,0x01,0xFF,0x8E,0x3F,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0x00,0x00,0x03,0xFF,0x9C,0x3F,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0x80,0x00,0x07,0xFF,0xFC,0x1F,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0x80,0x00,0x0F,0xFF,0xFC,0x1F,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0x80,0x00,0x1F,0xFF,0xF8,0x1F,0xFF,0xFF,0xFF,0xFF,0xFF,0xEF,0x80,0x00,0x7F,0xFF,0xF0,0x0F,0xFF,0xFF,0xFF,0xFF,0xFF,0xEF,0xC0,0x00,0xFF,0xFF,0xF0,0x07,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xC0,0x01,0xFF,0xFF,0xE0,0x03,0xFF,0xFF,0xFF,0xFF,0xFF,0xE7,0xC0,0x03,0xFF,0xFF,0xE0,0x03,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xC0,0x0F,0xFF,0xFF,0x80,0x01,0xFF,0xFF,0xFF,0xFF,0xFF,0xE7,0xE0,0x3F,0xFF,0xFF,0x80,0x00,0xFF,0xFF,0xFF,0xFF,0xFF,0xE7,0xFB,0xFF,0xFF,0xFF,0x00,0x00,0x7F,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFE,0x00,0x00,0x3F,0xFF,0xFF,0xFF,0xFF,0xF7,0xFF,0xFF,0xFF,0xFC,0x00,0x00,0x1F,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xF8,0x00,0x00,0x0F,0xFF,0xFF,0xFF,0xFF,0xE7,0xFF,0xFF,0xFF,0xF0,0x00,0x00,0x03,0xFF,0xFF,0xFF,0xFF,0xE3,0xFF,0xFF,0xFF,0xE0,0x00,0x00,0x00,0x3F,0xFF,0xFF,0xFF,0xE3,0xFF,0xFF,0xFC,0x00,0x00,0x00,0x00,0x0F,0xFF,0xFF,0xFF,0xE3,0xFF,0xFF,0xF8,0x00,0x00,0x00,0x00,0x01,0xFF,0xFF,0xFF,0xE3,0xFF,0xFF,0xC0,0x00,0x00,0x00,0x00,0x00,0x7F,0xFF,0xFF,0xE3,0xFF,0xFF,0x80,0x00,0x00,0x00,0x00,0x00,0x0F,0xFF,0xFF,0xE3,0xFF,0xF8,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x03,0xFF,0xF7,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x03,0xFF,0xF7,0x80,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x03,0xFF,0xEF,0x80,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x03,0xFF,0xE7,0x80,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x03,0xFF,0xF7,0x80,0x00,0x00,0x00,0x00
},&(SCR_RECT){{0,0,239,127}},A_REPLACE);
}


// Main Function

	void _main(void)
{

// Increase the Timer Speed,for more precision...
pokeIO(0x600017,0xFA);

/*Save Int5 and load our Clock*/
oldint5 = GetIntVec(AUTO_INT_5);
SetIntVec(AUTO_INT_5, myint5handler);

/*Save Int1 and redirect it to DUMMY_HANDLER*/
/*Because we use _rowread and GrayScale*/

INT_HANDLER save_int_1;
save_int_1 = GetIntVec (AUTO_INT_1);
SetIntVec (AUTO_INT_1, DUMMY_HANDLER); 

/*Reset the Clock,stop it*/
reset = 1;   
run=0;

GrayOn();

/*Draw the Stop Watch Bitmap*/
draw_stop_watch();

DrawStr(100+40,10+10,"StopWatch",A_NORMAL);
FontSetSys(F_6x8);
DrawStr(104+40,22+16,"by David Coz",A_NORMAL);
DrawStr(80+30,92+20,"coz.hubert@infonie.fr",A_NORMAL);

DrawStr(100+40,45+18,"[F1] = Run/Stop",A_NORMAL);
DrawStr(100+40,53+20,"[F5] = Reset",A_NORMAL);


// A variable for the key delay
long int key_delay =-100;

// Main Loop
while (!(_rowread(~((short)(1<<8))) & (1<<6))) // Quit if you press ESC
{
display_digit(); //Display the Digits
	
//if you press 2nd and 30 (pseudo) millesec has passed since the 
//last key press...	
		if (_rowread(~((short)(1<<6))) & (1<<4)&&ms-key_delay>30)
		{
		//Update the key delay counter
			key_delay=ms;
			//If it was running,stop
			//if it was stop,run
				if (run==0)
				{
				run=1;
				continue;
				}
    		run=0;
		}

//if you press Diamond and 30 (pseudo) millesec has passed since the 
//last key press...	

    if ((_rowread(~((short)(1<<7))) & (1<<4))&&run==0&&ms-key_delay>30)
		{
		// Reset Values
		reset=1;	
		// Reset key delay counter
		key_delay =-100;			
		}
}

GrayOff();

/* Load our old Timers*/
SetIntVec(AUTO_INT_5, oldint5);
SetIntVec (AUTO_INT_1, save_int_1);

/*Recover Normal Speed,depending on the Hw version*/ 
pokeIO(0x600017,0xCC);  
	if (GetHardwareVersion()!=2)
 pokeIO(0x600017,0xB2);

}

// Author   :  David Coz  
// Mail     :  Coz.hubert@infonie.fr
